﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Logger8
{
    public partial class Form1 : Form
    {

        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.Winapi)]
        public extern static long CH341OpenDevice(int i);

        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.Winapi)]
        public extern static void CH341CloseDevice(int iIndex);

        // CH341StreamI2C(ChipIndex.Value,wlen,@outbytes,rlen,@inbytes); 
        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.StdCall)]
        public extern static bool CH341StreamI2C(int iIndex, int wlen, ref byte WBuf, int rlen, ref byte RBuf);

        // CH341SetStream() konfiguriert I2C und SPI
        // Bit 1-0: I2C speed 00= low speed /20KHz
        // 01= standard /100KHz
        // 10= fast /400KHz
        // 11= high speed /750KHz           plus  0x60  , das ist wichtig. Also :
        // BOOL	WINAPI	CH341SetStream( ULONG iIndex, ULONG	iMode );*/
        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.Winapi)]
        public extern static long CH341SetStream(int iIndex, int iMode);

        // CH341WriteI2C( ULONG iIndex, UCHAR iDevice, UCHAR iAddr, UCHAR iByte );
        [DllImport("ch341dll.DLL", CallingConvention = CallingConvention.Winapi)]
        public extern static bool CH341WriteI2C(int iIndex, byte i1, byte i2, byte i3);
        // Calling convention: Cdecl geht nicht, PInvokeStackImbalance- Fehler
        //.FastCall :Ungültige nicht verwaltete Aufrufkonvention ("stdcall", "cdecl" oder "thiscall" ist erforderlich). 
        // .stdCall : OK
        // .ThisCall :  PInvokeStackImbalance- Fehler
        // .WinApi : OK
        //BOOL WINAPI CH341WriteI2C( ULONG iIndex, UCHAR iDevice, UCHAR iAddr, UCHAR iByte );


        byte[] WriteBuf = new byte[10];
        byte[] ReadBuf = new byte[10];
        bool initOK = false;
        int[] offset = new int[9];
        


        public Form1()
        {
            InitializeComponent();
            offset[1] = 0;   // manual offset comp 
            offset[2] = -16;
            offset[3] = 8*16;
            offset[4] = 2*16;
            offset[5] = 16;
            offset[6] = 7*16;
            offset[7] = -16;
            offset[8] = 16;
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            timer1.Interval = (int)numericUpDown1.Value * 1000;
        }

        private void lab10sec_Click(object sender, EventArgs e)
        {
            numericUpDown1.Value = 10;
        }

        private void lab1Min_Click(object sender, EventArgs e)
        {
            numericUpDown1.Value = 60;
        }

        private void butStop_Click(object sender, EventArgs e)
        {
            timer1.Stop();
            tsslab.Text = "Stop";
        }

        private void butStart_Click(object sender, EventArgs e)
        {
            timer1.Start();
        }

        long seccnt = 0;double Factorchart = 1.0;
        int alleSec = 1;
        StringBuilder log = new StringBuilder();
        private void timer1_Tick(object sender, EventArgs e)
        {
            double grad = 0;
            int binval = 0;
            if (rBsec.Checked) Factorchart = 1;
            else if (rBMin.Checked) Factorchart = 60;
            else Factorchart = 3600;
            seccnt += (int)numericUpDown1.Value;
            long tag = seccnt / 86400;
            long hour = (seccnt - 86400 * tag) / 3600;
            long min = (seccnt - 86400 * tag - hour * 3600) / 60;
            long sec = seccnt - 86400 * tag - hour * 3600 - min * 60;
            tsslab.Text = "running seit " + tag.ToString() + " Tagen, " + hour.ToString() + " Stunden, " + min.ToString() + " Minuten und " + sec.ToString() + " Sekunden";
            log.Append(seccnt.ToString()+" ");
            for (int i=1;i<=numericUpDown2.Value;i++)
            {
                ReadTemp(i, ref grad,ref binval);
                switch (i)
                {
                    //case 1: labTemp1.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " + binval.ToString("x4"); break; // debugging
                    //case 2: labTemp2.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " + binval.ToString("x4"); break;
                    //case 3: labTemp3.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " + binval.ToString("x4"); break;
                    //case 4: labTemp4.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " + binval.ToString("x4"); break;
                    //case 5: labTemp5.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " + binval.ToString("x4"); break;
                    //case 6: labTemp6.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " + binval.ToString("x4"); break;
                    //case 7: labTemp7.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " + binval.ToString("x4"); break;
                    //case 8: labTemp8.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " + binval.ToString("x4"); break;
                    case 1: labTemp1.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " ; log.Append(grad.ToString("f1") + " "); break;
                    case 2: labTemp2.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " ; log.Append(grad.ToString("f1") + " "); break;
                    case 3: labTemp3.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " ; log.Append(grad.ToString("f1") + " "); break;
                    case 4: labTemp4.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " ; log.Append(grad.ToString("f1") + " "); break;
                    case 5: labTemp5.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " ; log.Append(grad.ToString("f1") + " "); break;
                    case 6: labTemp6.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " ; log.Append(grad.ToString("f1") + " "); break;
                    case 7: labTemp7.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " ; log.Append(grad.ToString("f1") + " "); break;
                    case 8: labTemp8.Text = "Sensor " + i.ToString() + ": " + grad.ToString("f1") + "°C  " ; log.Append(grad.ToString("f1") + "\r\n "); break;
                }
                chart2D1.setPoint(i-1, seccnt / Factorchart, grad);
                if (seccnt > 5)
                    if (seccnt % alleSec == 0) DisplayStore();
                if (seccnt > 1000) alleSec = 10;
                if (seccnt > 10000) alleSec = 100;
                if (seccnt > 1000000) alleSec = 1000;
                if (seccnt > 10000000) alleSec = 10000;
                
            }

        }

        private void DisplayStore()
        {
            chart2D1.startDrawing();
            chart2D1.autoScaling();
            StreamWriter sw = new StreamWriter("logfile.txt");
            sw.WriteLine(log);
            sw.Close();
        }

        private void butReset_Click(object sender, EventArgs e)
        {
            seccnt = 0;
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            if (numericUpDown2.Value < 8) labTemp8.Visible = false; else labTemp8.Visible = true;
            if (numericUpDown2.Value < 7) labTemp7.Visible = false; else labTemp7.Visible = true;
            if (numericUpDown2.Value < 6) labTemp6.Visible = false; else labTemp6.Visible = true;
            if (numericUpDown2.Value < 5) labTemp5.Visible = false; else labTemp5.Visible = true;
            if (numericUpDown2.Value < 4) labTemp4.Visible = false; else labTemp4.Visible = true;
            if (numericUpDown2.Value < 3) labTemp3.Visible = false; else labTemp3.Visible = true;
            if (numericUpDown2.Value < 2) labTemp2.Visible = false; else labTemp2.Visible = true;
        }
       
        string extreadword = "80";
        void ReadTemp(int chan,ref double val,ref int binval)
        {
            WriteBuf[0] = Convert.ToByte("30", 16); // Init ADC
            WriteBuf[2] = 255; // Idee für Pause zwischen Write und read beim Stream --> nützt nix
            WriteBuf[3] = 255; // Idee für Pause zwischen Write und read beim Stream
            string readword ="80";
            switch (chan)  // Kanal 1-8 umschalten
            {
                case 1: readword = "80"; break;
                case 2: readword = "C0"; break;
                case 3: readword = "90"; break; 
                case 4: readword = "D0"; break;
                case 5: readword = "A0"; break;
                case 6: readword = "E0"; break;
                case 7: readword = "B0"; break;
                case 8: readword = "F0"; break;
            }

            WriteBuf[1] = Convert.ToByte(readword, 16);

            CH341StreamI2C(0, 2, ref WriteBuf[0], 2, ref ReadBuf[0]);  // Start conversion
           
            CH341StreamI2C(0, 1, ref WriteBuf[0], 2, ref ReadBuf[0]); // nur lesen
           

            binval = ReadBuf[0] * 256 + ReadBuf[1] +offset[chan];   // 4095 = Full scale = 4.096 V, aber bei unipolar nur 0-2047 ist 0-4.047V
            val = binval / 160.0;  // in °C
        }

        private void butconnect_Click(object sender, EventArgs e)
        {
            try
            {
                long open = CH341OpenDevice(0);
                if (open != 4294967295)
                {
                    tsslab.Text = "Chip open with" + open.ToString("X16");
                    initOK = true;
                    butconnect.BackColor = Color.LightGreen;
                }
                else
                {
                    tsslab.Text = "No Chip could be opened";
                    initOK = false;
                    butconnect.BackColor = Color.LightSalmon;

                }
                if (initOK)
                {
                    CH341SetStream(0, 0x61);//100 kHz Mode
                    //CH341SetStream(0, 0x60);//200 kHz Mode

                }
            }
            catch
            {
                MessageBox.Show("No DLL");
            }

        }

 
    }
}
